<template>
  <div class="todo-item">
    <div class="number column">{{ itemIndex }}</div>
    <div class="activities column">
      <span class="todo-act" v-if="todoView">{{ item.todo }}</span>
      <div class="edit-container" v-else>
        <edit-input
          class="edit-input"
          @accept="acceptEdit"
          @reject="cancelEdit"
          v-model="editedTodo"
        />
      </div>
    </div>
    <div class="edit column"><todo-edit @click="onEdit"/></div>
    <div class="delete column"><todo-delete @click="onDelete"/></div>
    <div class="status column">
      <checkbox-component
        :done="item.done"
        @change="onChangeStatus"
      />
    </div>
  </div>
</template>

<script>
import checkboxComponent from '../UI/checkbox-component'
import todoDelete from '../UI/todo-delete'
import todoEdit from '../UI/todo-edit'
import editInput from '../UI/edit-input'

export default {
  name: 'todo-item',
  components: {
    checkboxComponent,
    todoDelete,
    todoEdit,
    editInput
  },
  computed: {
    itemIndex () {
      return this.index + 1
    }
  },
  props: {
    item: {
      type: Object,
      required: true
    },
    index: {
      type: Number,
      required: true
    }
  },
  methods: {
    onChangeStatus () {
      this.$store.commit('changeStatus', this.index)
    },
    onDelete () {
      this.$emit('on-delete', this.index)
    },
    onEdit () {
      this.editedTodo = this.item.todo
      this.todoView = !this.todoView
    },
    cancelEdit () {
      this.todoView = !this.todoView
    },
    acceptEdit () {
      this.$store.commit('changeTodo', {
        index: this.index,
        newTodo: this.editedTodo
      })
      this.todoView = !this.todoView
    }
  },
  data () {
    return {
      editedTodo: '',
      todoView: true
    }
  }
}
</script>

<style scoped>
.todo-item {
  display: flex;
  justify-content: space-between;
  align-items: center;
  font-size: 24px;
  border-bottom: 1px solid rgba(210, 135, 0, 0.2);
  padding: 10px 0;
}

.column {
  display: flex;
  justify-content: center;
}

.column::selection {
  background-color: #D28700FF;
  color: #fff;
}

span::selection {
  background-color: #D28700FF;
  color: #fff;
}

.number {
  width: 100px;
}

.activities {
  width: 400px;
  word-break: break-word;
}

.edit {
  width: 100px;
}

.delete {
  width: 100px;
}

.status {
  width: 100px;
}

@media screen and (max-width: 780px) {
  .activities {
    width: 200px;
  }
  .column {
    font-size: 22px;
  }
}

@media screen and (max-width: 570px) {
  .number {
    display: none;
  }
  .activities {
    padding-left: 3px;
    font-size: 20px;
  }
  .status {
    line-height: 40px;
  }
}
</style>
